import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Sidepane extends JPanel implements Observer
{
  private Model model;
  private Colours colours;
  private JPanel thiccness;

  // Bob the Builder this shit
  public Sidepane(Model model, Handler handler)
  {
    // Hook up this observer so that it will be notified when the model
    // changes.
    this.model = model;
    this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    this.setPreferredSize(new Dimension(280, 720));
    colours = new Colours(model);
    this.add(colours);
    model.addObserver(this);
  }

  /**
  * Update with data from the model.
  */
  public void update(Object observable)
  {
    this.setBackground(model.sideColour);
    revalidate();
    repaint();
  }
}

class Colours extends JPanel
{
  private Model model;
  private ArrayList<colourButton> colours;

  public Colours(Model m)
  {
    this.model = m;
    this.setLayout(new GridLayout(0, 2));
    this.setPreferredSize(new Dimension(280, 600));
    this.colours = new ArrayList();
    colourButton.model = m;
    colours.add(new colourButton(Color.red));
    colours.add(new colourButton(Color.green));
    colours.add(new colourButton(Color.blue));
    colours.add(new colourButton(Color.yellow));
    colours.add(new colourButton(Color.magenta));
    colours.add(new colourButton(Color.orange));
    colours.add(new colourButton(Color.cyan));
    colours.add(new colourButton(Color.gray));
    
    for(colourButton b: colours)
    {
      this.add(b);
      b.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          colourButton.model.changeColour(b.getBackground());
        }
      });
    }
  }
}

class colourButton extends JButton
{
  public static Model model;

  public colourButton(Color c)
  {
    this.setPreferredSize(new Dimension(140, 150));
    this.setBackground(c);
    this.setOpaque(true);
  }
  
  public String toString()
  {
    return this.getBackground().toString();
  }
}

class previewPanel extends JPanel
{
  private Model model;
  private JSlider slider;
  private previewLine preview;
  
  public previewPanel(Model m)
  {
    this.model = m;
    this.slider = new JSlider(1, 50, model.getThiccness());
    this.slider.addChangeListener(new ChangeListener()
      {
        public void stateChanged(ChangeEvent e)
        {
          this.model.changeThiccness(slider.getValue());
        }
      });
    this.preview = new previewLine(m);
  }
}

class previewLine
{
  private int xpos;
  private int ypos;
  private Model model;
  
  public previewLine(Model m)
  {
    this.model = m;
    model.addObserver(this);
  }

  public void update(Object observable)
  {
    revalidate();
    repaint();
  }
  
  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    Graphics2D gtemp = (Graphics2D) g;
    gtemp.setColor(model.getColour());
    gtemp.setStroke(new BasicStroke(model.getThiccness(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
    gtemp.drawLine(xpos, ypos, xpos, ypos);
  }
}